package cn.estsh.i3plus.pojo.mes.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @Description:
 * @Reference:
 * @Author: jessica.chen
 * @CreateDate:
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_BLIND_RULE")
@Api("MES_盲检规则")
public class MesBlindRule extends BaseBean implements Serializable {
    private static final long serialVersionUID = -7459452475180601498L;

    @Column(name = "RULE_ID")
    @ApiParam("匹配规则ID")
    private String ruleId;

    @Column(name = "CAR_TYPE")
    @ApiParam("车辆类型")
    private String carType;

    @Column(name = "CAR_COLOR")
    @ApiParam("车辆颜色")
    private String carColor;

    @Column(name = "PART_CODE")
    @ApiParam("零件号")
    private String partCode;

    @Column(name = "PART_NAME")
    @ApiParam("零件名称")
    private String partName;

    @Column(name = "CAR_CONFIG")
    @ApiParam("配置")
    private String carConfig;

    @Column(name = "CAR_LEVEL")
    @ApiParam("等级")
    private String carLevel;

    @Column(name = "PART_COLOR")
    @ApiParam("零件颜色")
    private String partColor;

}
